local assets=
{
	Asset("ANIM", "data/anim/livinglog.zip"),
    Asset("IMAGE", "data/inventoryimages/livinglog.tex"),
}

local function FuelTaken(inst, taker)
    if taker and taker.SoundEmitter then
        taker.SoundEmitter:PlaySound("dontstarve/creatures/leif/livinglog_burn")
    end
end

--MOD--
local function test_ground(inst, pt)
	local tiletype = GetGroundTypeAtPosition(pt)
	local ground_OK = tiletype == tiletype ~= GROUND.ROCKY and tiletype ~= GROUND.ROAD and tiletype ~= GROUND.IMPASSABLE
	
	if ground_OK then
	    local ents = TheSim:FindEntities(pt.x,pt.y,pt.z, 4)
		local min_spacing = inst.components.deployable.min_spacing or 2

	    for k, v in pairs(ents) do
			if v ~= inst and v.entity:IsValid() and v.entity:IsVisible() and not v:HasTag("player") and not v.components.placer and v.parent == nil and not v:HasTag("FX") then
				if distsq( Vector3(v.Transform:GetWorldPosition()), pt) < min_spacing*min_spacing then
					return false
				end
			end
		end
		
		return true

	end
	return false
	
end

local function CanDeploy(inst) return true end
local function OnDeploy (inst, pt, deployer) 
    local flower = SpawnPrefab("leif")
    if flower and deployer.components.sanity then
	    deployer.components.sanity:DoDelta(-TUNING.SANITY_MED)
		flower.Transform:SetPosition(pt.x, pt.y, pt.z)
        inst.components.stackable:Get():Remove()
		flower.SoundEmitter:PlaySound("dontstarve/wilson/plant_tree")
		flower.SoundEmitter:PlaySound("dontstarve/creatures/leif/transform_VO")
        flower.AnimState:PlayAnimation("transform_ent")
    end
end
--/MOD--

local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()    
    
    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("livinglog")
    inst.AnimState:SetBuild("livinglog")
    inst.AnimState:PlayAnimation("idle")
    
    inst:AddComponent("stackable")
    
    inst:AddComponent("fuel")
    inst.components.fuel.fuelvalue = TUNING.MED_FUEL
    inst.components.fuel:SetOnTakenFn(FuelTaken)
    
    
	MakeSmallBurnable(inst, TUNING.MED_BURNTIME)
    MakeSmallPropagator(inst)

    ---------------------       
    
    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
	
	--MOD--
    inst:AddComponent("deployable")
    inst.components.deployable.ondeploy = OnDeploy
	inst.components.deployable.test = test_ground
	--/MOD--
    
	inst:AddComponent("repairer")
	inst.components.repairer.repairmaterial = "wood"
	inst.components.repairer.value = TUNING.REPAIR_LOGS*3

	inst:ListenForEvent("onignite", function(inst) inst.SoundEmitter:PlaySound("dontstarve/creatures/leif/livinglog_burn") end)
    
    return inst
end

return Prefab( "common/inventory/livinglog", fn, assets),
    MakePlacer( "common/livinglog_placer", "pinecone", "pinecone", "idle_planted" )--/MOD--

