local assets =
{
	--Asset("ANIM", "data/anim/fire_large_character.zip"),
	Asset("ANIM", "data/anim/campfire_fire.zip"),
	Asset("SOUND", "data/sound/common.fsb"),
}

local heats = { 70, 120, 180, 220 }
local function GetHeatFn(inst)
	return heats[inst.components.firefx.level] or 150
end

local firelevels = 
{
    {anim="level1", sound="dontstarve/common/campfire", radius=2, intensity=.75, falloff= 1, colour = {220/250,24/154,68/48}, soundintensity=.1},
    {anim="level2", sound="dontstarve/common/campfire", radius=2.5, intensity=.8, falloff=.9, colour = {15/255, 15/255, 255/255}, soundintensity=.3},
    {anim="level3", sound="dontstarve/common/campfire", radius=3, intensity=.8, falloff=.8, colour = {180/255, 195/255, 50/255}, soundintensity=.6},
    {anim="level4", sound="dontstarve/common/campfire", radius=3.5, intensity=.9, falloff=.7, colour = {250/250,154/154,48/48}, soundintensity=1},
    {anim="level1", sound="dontstarve/common/campfire", radius=2, intensity=.75, falloff=.4, colour = {220/250,24/154,68/48}, soundintensity=.1},
    {anim="level2", sound="dontstarve/common/campfire", radius=3, intensity=.8, falloff=.4, colour = {15/255, 15/255, 255/255}, soundintensity=.3},
    {anim="level3", sound="dontstarve/common/campfire", radius=4, intensity=.8, falloff=.4, colour = {180/255, 195/255, 50/255}, soundintensity=.6},
    {anim="level4", sound="dontstarve/common/campfire", radius=6, intensity=.9, falloff=.4, colour = {250/250,154/154,48/48}, soundintensity=1},
}

local function onignite(inst)
    if not inst.components.cooker then
        inst:AddComponent("cooker")
    end
end

local function fn(Sim)

	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()
	local light = inst.entity:AddLight()

    inst:AddTag("NOCLICK")

    anim:SetBank("campfire_fire")
    anim:SetBuild("campfire_fire")
    anim:SetBloomEffectHandle( "data/shaders/anim.ksh" )
    inst.AnimState:SetRayTestOnBB(true)
    inst.AnimState:SetMultColour(60/255, 179/255, 113/255, .6)
    
    inst:AddTag("fx")
    
    inst:AddComponent("firefx")
    inst.components.firefx.levels = firelevels
    inst.components.firefx.lightsound = "dontstarve/common/campfire"
    inst.components.firefx.extinguishsound =  "dontstarve/common/maxlightOut" 

    inst:AddComponent("heater")
    inst.components.heater.heatfn = GetHeatFn

    anim:SetFinalOffset(-1)
    return inst
end

return Prefab( "common/fx/maxwelllight_flame", fn, assets)
