-- PigLight
-- DontStarver
-- prior version 1.1 [underground]

require "prefabutil"
local assets =
{
--	Asset("ANIM", "data/anim/nightmare_torch.zip"),
--	Asset("ANIM", "data/anim/nightmare_torch.zip"),
--	Asset("ANIM", "data/anim/pig_torch.zip"),
--	Asset("ANIM", "data/anim/marble_pillar.zip"),
--	Asset("ANIM", "data/anim/lightning_rod_fx.zip"),
	Asset("ANIM", "data/anim/maxwell_torch.zip"),
-- #######################################
--    Asset("IMAGE", "mods/Piglight/inventoryimages/nightlight.tex"),
 Asset("IMAGE", "data/inventoryimages/nightlight.tex"),
-- #######################################
	Asset("SOUND", "data/sound/common.fsb"),
}
local prefabs =
{
    "campfirefire",
}

local heats = { 70, 120, 180, 220 }
local function GetHeatFn(inst)
	return heats[inst.components.firefx.level] or 20
end

 local function HAMMER(inst)
	SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
	RemovePhysicsColliders(inst)
	inst:Remove()
end
local function HitOnce(inst, worker)
end
local function changelevels(inst, order)
    for i=1, #order do
        inst.components.burnable:SetFXLevel(order[i])
        Sleep(20.00)					--0.05
        inst.components.burnable:SetFXLevel(order[2])
        Sleep(20.00)					--0.05
        inst.components.burnable:SetFXLevel(order[3])
        Sleep(80.00)					--0.05
	inst.components.burnable:SetFXLevel(order[4])
        Sleep(180.00)
    end
end
local function light(inst)    
    inst.task = inst:StartThread(function() changelevels(inst, inst.lightorder) end)
--	inst.SoundEmitter:PlaySound("dontstarve/common/lightningrod")
--    PlayFX(Vector3(inst.Transform:GetWorldPosition() ), "lightning_rod_fx", "lightning_rod_fx", "idle")
end
local function extinguish(inst)
    if inst.components.burnable:IsBurning() then
        inst.components.burnable:Extinguish()
    end
end
local function onbuilt(inst)
--	inst.SoundEmitter:PlaySound("")
	--inst.AnimState:PlayAnimation("place")
	inst.AnimState:PushAnimation("idle", false)
end
local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	
    inst.entity:AddSoundEmitter()

    inst:AddComponent("heater")
    inst.components.heater.heatfn = GetHeatFn

    local minimap = inst.entity:AddMiniMapEntity()
    minimap:SetIcon("maxwelltorch.png")
	
	trans:SetRotation( 90 )
	inst.shaderFX_1 = anim:SetBloomEffectHandle("data/shaders/anim.ksh")
	inst.shaderFX_2 = anim:SetBloomEffectHandle("")
--	inst.Transform:SetScale(.80,.80,.80)
	
    anim:SetBank("maxwell_torch")
    anim:SetBuild("maxwell_torch")
    anim:PlayAnimation("idle",false)
    inst.AnimState:SetRayTestOnBB(false);
	
-- inst:AddTag("NOCLICK")
	inst:AddTag("nightlight")
    inst:AddTag("structure")
    MakeObstaclePhysics(inst, .1)    

	inst:AddComponent("workable")
	inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
	inst.components.workable:SetWorkLeft(8)
	inst.components.workable:SetOnFinishCallback(HAMMER)
	inst.components.workable:SetOnWorkCallback(HitOnce)

    inst:AddComponent("burnable")
	
	inst.burnFX_1 = inst.components.burnable:AddBurnFX("maxwelllight_flame", Vector3(10, 0, 0), "fire_marker")
--	inst.burnFX_2 = inst.components.burnable:AddBurnFX("maxwelllight_flame", Vector3(10, 2, 0), "fire_marker")
--	inst.burnFX_3 = inst.components.burnable:AddBurnFX("maxwelllight_flame", Vector3(2, 5, 0), "fire_marker")
--	inst.burnFX_4 = inst.components.burnable:AddBurnFX("maxwelllight_flame", Vector3(0, 0, 0), "fire_marker")
	
--	inst.components.burnable:AddBurnFX("maxwelllight_flame", Vector3(10, 0, 0), "fire_marker")
--	PlayFX(Vector3(0, 0, 0), "lightning_rod_fx", "lightning_rod_fx", "idle")
    inst.components.burnable:SetOnIgniteFn(light)
        inst:AddComponent("cooker")

    inst:AddComponent("inspectable")
    inst:ListenForEvent( "onbuilt", onbuilt)
    return inst
end
local function arealight()
    local inst = fn()
	
    inst.lightorder = {5,6,7,8,7}
    inst:AddComponent("playerprox")
    inst.components.playerprox:SetDist(15, 15)
    inst.components.playerprox:SetOnPlayerNear(function() 
	if not inst.components.burnable:IsBurning() then 
	inst.components.burnable:Ignite() end end)
    inst.components.playerprox:SetOnPlayerFar(extinguish)

--    inst:AddTag("NOCLICK")
--    inst:AddComponent("named")
--    inst.components.named:SetName(STRINGS.NAMES["MAXWELLLIGHT"])
--    inst.components.inspectable.nameoverride = "maxwelllight"
	
--	inst:DoTaskInTime(0, function()  end)
	 return inst
end

return Prefab( "common/objects/nightlight", arealight, assets, prefabs),
MakePlacer( "common/nightlight_placer", "maxwell_torch", "maxwell_torch", "idle" )